package java.beans;

import java.util.Iterator;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;
import java.util.Enumeration;
import java.awt.image.ImageProducer;
import java.awt.Image;
import java.applet.AudioClip;
import java.net.URL;
import java.util.Hashtable;
import java.applet.Applet;
import java.applet.AppletContext;

class BeansAppletContext implements AppletContext
{
    Applet target;
    Hashtable<URL, Object> imageCache;
    
    BeansAppletContext(Applet target) {
        this.imageCache = new Hashtable();
        this.target = target;
    }
    
    @Override
    public AudioClip getAudioClip(URL url) {
        try {
            return (AudioClip)url.getContent();
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    @Override
    public synchronized Image getImage(URL key) {
        Object value = this.imageCache.get(key);
        if (value != null) {
            return (Image)value;
        }
        try {
            Object content = key.getContent();
            if (content == null) {
                return null;
            }
            if ((content instanceof Image)) {
                this.imageCache.put(key, content);
                return (Image)content;
            }
            Image image = this.target.createImage((ImageProducer)content);
            this.imageCache.put(key, image);
            return image;
        }
        catch (Exception ex) {
            return null;
        }
    }
    
    @Override
    public Applet getApplet(String s) {
        return null;
    }
    
    @Override
    public Enumeration<Applet> getApplets() {
        Vector<BeansAppletContext> vector = new Vector();
        vector.addElement(this.target);
        return vector.elements();
    }
    
    @Override
    public void showDocument(URL url) {
    }
    
    @Override
    public void showDocument(URL url, String s) {
    }
    
    @Override
    public void showStatus(String s) {
    }
    
    @Override
    public void setStream(String s, InputStream inputStream) throws IOException {
    }
    
    @Override
    public InputStream getStream(String s) {
        return null;
    }
    
    @Override
    public Iterator<String> getStreamKeys() {
        return null;
    }
}
